#include <PalmOS.h>

#include "ExtWinMod.h"
#include "ExtWinModSamp.h"

#include "StarterRsc.h"

#pragma mark //----[eBeB
static UInt32 ExtUtilGetMgrVersion(ExtWinModControlType *modCtrl)
{
	UInt32	value;
	UInt32	version=extWinVersionNum1;
	ExtWinGetMgrVersionCallBackPtr	ExtWinGetMgrVersion;
	Err	err;

	err=FtrGet(extWinFtrCreator,extWinFtrIDManagerVersionChkCallBack,&value);
	if(err!=errNone){
		//Ftrݒ肳ĂȂ̂ŁAVersion1(o[W)
		version=extWinVersionNum1;
	}else{
		//Ftrݒ肳Ă̂ŁAR[obN֐Versionl
		ExtWinGetMgrVersion=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinGetMgrVersionCallBackNo);
		version=ExtWinGetMgrVersion();
	}

	return version;
}

static WinHandle ExtUtilGetBgImageWindow(ExtWinModControlType *modCtrl)
{
	WinHandle	ret=NULL;
	
	ExtWinGetBgImageWindowCallBackPtr	ExtWinExtWinGetBgImageWindow;

	if(ExtUtilGetMgrVersion(modCtrl)<extWinVersionNum2){
		//o[WȂ̂ lłȂ
		ret=NULL;
	}else{
		//R[obNŊl
		ExtWinExtWinGetBgImageWindow=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinGetBgImageWindowCallBackNo);
		ret=ExtWinExtWinGetBgImageWindow();
	}
	
	return ret;
}

static void ExtUtilEraseRectangle(ExtWinModControlType *modCtrl,RectangleType *r)
{
	WinHandle	winH;
	
	ExtWinEraseRectangleCallBackPtr	ExtWinErase;

	if(ExtUtilGetMgrVersion(modCtrl)<extWinVersionNum2){
		//o[WȂ̂ ExtWinErase g
		ExtWinErase=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinEraseRectangleCallBackNo);
		ExtWinErase(r,0);
	}else{
		//wi`ς݃EBhEg
		winH=ExtUtilGetBgImageWindow(modCtrl);
		if(winH!=NULL){
			WinCopyRectangle(winH,WinGetDrawWindow(),r,r->topLeft.x,r->topLeft.y,winPaint);
		}
	}
	
}

static Boolean ExtUtilUpdateWindow(ExtWinModControlType *modCtrl)
{
	Boolean	ret=false;

	ExtWinUpdateWindowCallBackPtr	ExtWinUpdateWindow;

	if(ExtUtilGetMgrVersion(modCtrl)<extWinVersionNum2){
		//o[WȂ̂ŃCxgsłȂ
		ret=false;
	}else{
		//R[obNŃCxgs
		ExtWinUpdateWindow=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinUpdateWindowCallBackNo);
		ExtWinUpdateWindow();
		ret=true;
	}
	
	return ret;
}

static void ExtUtilGetMgrOwnerTypeCreator(ExtWinModControlType *modCtrl,UInt32 *typeP,UInt32 *creatorP)
{

	ExtWinGetMgrOwnerTypeCreatorCallBackPtr	ExtWinGetMgrOwnerTypeCreator;

	if(ExtUtilGetMgrVersion(modCtrl)<extWinVersionNum2){
		//o[WȂ̂ AppShelf Œ
		if(typeP!=NULL){
			*typeP='appl';
		}
		if(creatorP!=NULL){
			*creatorP='APsh';
		}
	}else{
		//R[obNŊl
		ExtWinGetMgrOwnerTypeCreator=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinGetMgrOwnerTypeCreatorCallBackNo);
		ExtWinGetMgrOwnerTypeCreator(typeP,creatorP);
	}

}

static Int8 ExtUtilGetModuleMenuID(ExtWinModControlType *modCtrl)
{
	Int8	id=0;


	ExtWinGetModuleMenuIDCallBackPtr	ExtWinGetModuleMenuID;

	if(ExtUtilGetMgrVersion(modCtrl)<extWinVersionNum2){
		//o[WȂ̂ AppShelf Œ ID->0 ̂
		id=0;
	}else{
		//R[obNŊl
		ExtWinGetModuleMenuID=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinGetModuleMenuIDCallBackNo);
		id=ExtWinGetModuleMenuID();
	}

	return id;
}

static Boolean ExtUtilChkFuncNo(ExtWinModControlType *modCtrl,UInt16 funcNo)
{
	Boolean	ret=false;


	ExtWinChkFuncNoCallBackPtr	ExtWinChkFuncNo;

	if(ExtUtilGetMgrVersion(modCtrl)==extWinVersionNum1){
		//o[WȂ̂ŔsB
		//o[W҂Ă邱Ƃ\ẑ false Ԃ
		ret=false;
	}else{
		//R[obNŊl
		ExtWinChkFuncNo=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinChkFuncNoCallBackNo);
		ret=ExtWinChkFuncNo(funcNo);
	}

	return ret;
}

static FieldType *ExtUtilGetFocusField(ExtWinModControlType *modCtrl)
{
	ExtWinGetFocusFieldCallBackPtr	ExtWinGetFocusField;
	FieldType	*ret=NULL;

	if(ExtUtilGetMgrVersion(modCtrl)<extWinVersionNum2){
		//lłȂB
		ret=NULL;
	}else{
		//R[obNŊl
		ExtWinGetFocusField=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinGetFocusFieldCallBackNo);
		ret=ExtWinGetFocusField();
	}

	return ret;
}

static ExtWinKeyFocusStatType ExtUtilGetKeyFocusStatus(ExtWinModControlType *modCtrl)
{
	ExtWinGetKeyFocusStatusCallBackPtr	ExtWinGetKeyFocusStatus;
	ExtWinKeyFocusStatType	ret=extWinKeyFocusStatNone;

	if(ExtUtilGetMgrVersion(modCtrl)<extWinVersionNum2){
		//lłȂB
		ret=extWinKeyFocusStatNone;
	}else{
		//R[obNŊl
		ExtWinGetKeyFocusStatus=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinGetKeyFocusStatusCallBackNo);
		ret=ExtWinGetKeyFocusStatus(modCtrl->pos);
	}

	return ret;
}


static Boolean ExtUtilChkKeyFocusSwEvent(ExtWinModControlType *modCtrl)
{
	ExtWinChkKeyFocusSwEventCallBackPtr	ExtWinChkKeyFocusSwEvent;
	Boolean	ret=false;

	if(ExtUtilGetMgrVersion(modCtrl)<extWinVersionNum2){
		//mFłȂB
		ret=false;
	}else{
		//R[obNŊl
		ExtWinChkKeyFocusSwEvent=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinChkKeyFocusSwEventCallBackNo);
		ret=ExtWinChkKeyFocusSwEvent(modCtrl->eventP);
	}

	return ret;
}

static void ExtUtilClearKeyFocus(ExtWinModControlType *modCtrl)
{
	ExtWinClearKeyFocusCallBackPtr	ExtWinClearKeyFocus;

	if(ExtUtilGetMgrVersion(modCtrl)<extWinVersionNum2){
		//tH[JXȂB
	}else{
		//R[obNŉ
		ExtWinClearKeyFocus=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinClearKeyFocusCallBackNo);
		ExtWinClearKeyFocus(modCtrl->pos);
	}

}

static void ExtUtilSetKeyFocusNext(ExtWinModControlType *modCtrl)
{
	ExtWinSetKeyFocusNextCallBackPtr	ExtWinSetKeyFocusNext;

	if(ExtUtilGetMgrVersion(modCtrl)<extWinVersionNum2){
		//tH[JXݒłȂB
	}else{
		//R[obNŐݒ
		ExtWinSetKeyFocusNext=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinSetKeyFocusNextCallBackNo);
		ExtWinSetKeyFocusNext();
	}

}

static void ExtUtilSetKeyFocusPrev(ExtWinModControlType *modCtrl)
{
	ExtWinSetKeyFocusPrevCallBackPtr	ExtWinSetKeyFocusPrev;

	if(ExtUtilGetMgrVersion(modCtrl)<extWinVersionNum2){
		//tH[JXݒłȂB
	}else{
		//R[obNŐݒ
		ExtWinSetKeyFocusPrev=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinSetKeyFocusPrevCallBackNo);
		ExtWinSetKeyFocusPrev();
	}

}

static void ExtUtilSetKeyFocusSetId(ExtWinModControlType *modCtrl,Int8 pos)
{
	ExtWinSetKeyFocusSetIdCallBackPtr	ExtWinSetKeyFocusSetId;

	if(ExtUtilGetMgrVersion(modCtrl)<extWinVersionNum2){
		//tH[JXݒłȂB
	}else{
		//R[obNŐݒ
		ExtWinSetKeyFocusSetId=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinSetKeyFocusSetIdCallBackNo);
		ExtWinSetKeyFocusSetId(pos);
	}

}

static Boolean ExtUtilSetKeyFocusDrawFrameStatus(ExtWinModControlType *modCtrl,Boolean set)
{
	ExtWinSetKeyFocusDrawFrameStatusCallBackPtr	ExtWinSetKeyFocusDrawFrameStatus;
	Boolean ret=false;

	if(ExtUtilGetMgrVersion(modCtrl)<extWinVersionNum2){
		//tH[JXݒłȂB
		ret=false;
	}else{
		//R[obNŐݒ
		ExtWinSetKeyFocusDrawFrameStatus=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinSetKeyFocusDrawFrameStatusCallBackNo);
		ret=ExtWinSetKeyFocusDrawFrameStatus(set);
	}

	return ret;
}

static Boolean ExtUtilGetKeyFocusDrawFrameStatus(ExtWinModControlType *modCtrl)
{
	ExtWinGetKeyFocusDrawFrameStatusCallBackPtr	ExtWinGetKeyFocusDrawFrameStatus;
	Boolean ret=false;

	if(ExtUtilGetMgrVersion(modCtrl)<extWinVersionNum2){
		//tH[JXݒłȂB
		ret=false;
	}else{
		//R[obNŊl
		ExtWinGetKeyFocusDrawFrameStatus=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinGetKeyFocusDrawFrameStatusCallBackNo);
		ret=ExtWinGetKeyFocusDrawFrameStatus();
	}

	return ret;
}

static Boolean ExtUtilGetSelectDay(ExtWinModControlType *modCtrl,UInt8 *month, UInt8 *day, UInt16 *year)
{
	Boolean ret=false;

	ExtWinGetSelectDayCallBackPtr	ExtWinGetSelectDay;

	if(ExtUtilGetMgrVersion(modCtrl)==extWinVersionNum1){
		//o[WȂ̂ŊlsB
		//o[W҂Ă邱Ƃ\ẑ false Ԃ
		ret=false;
	}else{
		//R[obNŊl
		ExtWinGetSelectDay=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinGetSelectDayCallBackNo);
		ret=ExtWinGetSelectDay(month, day, year);
	}

	return ret;
}

static Err ExtUtilSetSelectDay(ExtWinModControlType *modCtrl,Boolean set, UInt8 month, UInt8 day, UInt16 year)
{
	ExtWinSetSelectDayCallBackPtr	ExtWinSetSelectDay;
	Err	ret=errNone;

	if(ExtUtilGetMgrVersion(modCtrl)==extWinVersionNum1){
		//o[WȂ̂ŐݒsB
		ret=sysErrParamErr;
	}else{
		//R[obNŊl
		ExtWinSetSelectDay=(*(modCtrl->ExtWinGetCBFuncAddr))(ExtWinSetSelectDayCallBackNo);
		ret=ExtWinSetSelectDay(set, month, day, year);
	}
	
	return ret;
}


#pragma mark //----ݒ菈
static void * GetObjectPtr(UInt16 objectID)
{
	FormPtr frmP;

	frmP = FrmGetActiveForm();
	return FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, objectID));
}

static void ColorDrawButton(UInt16 id,RGBColorType btnRGB)
{
	RectangleType	r;
	FormType		*frmP;
	RGBColorType	rgb,saveRGB;
	
	frmP=FrmGetActiveForm();
	FrmGetObjectBounds(frmP,FrmGetObjectIndex(frmP,id),&r);
	
	WinSetForeColorRGB(&btnRGB,&saveRGB);
	WinDrawRectangle(&r,0);

	rgb.r=0;
	rgb.g=0;
	rgb.b=0;
	WinSetForeColorRGB(&rgb,NULL);
	WinDrawRectangleFrame(rectangleFrame,&r);

	WinSetForeColorRGB(&saveRGB,NULL);

}

static void ExtWinSettingDrawForm()
{
	ExtWinSettingGlbType	*glb;
	FormType				*frmP;
	RectangleType			r;
	Char					tmp[10];

	FtrGet(extFileCreator,extPrefFtr,(UInt32*)(&glb));
	
	frmP=FrmGetActiveForm();
	
	ColorDrawButton(ExtWinSettingTextButton,glb->pref.textColor);


	//I[i[`
	FrmGetObjectBounds(frmP,FrmGetObjectIndex(frmP,ExtWinSettingApplGadget),&r);
	WinPaintChars((Char*)(&glb->creator),4,r.topLeft.x,r.topLeft.y);

	//j[ID`
	StrIToA(tmp,glb->menuID);
	FrmGetObjectBounds(frmP,FrmGetObjectIndex(frmP,ExtWinSettingMenuIDGadget),&r);
	WinPaintChars(tmp,StrLen(tmp),r.topLeft.x,r.topLeft.y);

}

static Boolean ExtWinSettingDoControl(UInt16 controlID)
{
	IndexedColorType	tmp;
	ExtWinSettingGlbType	*glb;

	Boolean handled = false;

	FtrGet(extFileCreator,extPrefFtr,(UInt32*)(&glb));

	switch(controlID){
		case ExtWinSettingTextButton:
			tmp=WinRGBToIndex(&(glb->pref.textColor));
			UIPickColor(&tmp, &(glb->pref.textColor), UIPickColorStartPalette, 0,0);
			ExtWinSettingDrawForm();
			handled=true;
			break;			
	}
	
	return handled;
}


static Boolean ExtWinSettingHandleEvent(EventPtr eventP)
{
   Boolean handled = false;

	switch (eventP->eType){
		case appStopEvent:
			EvtAddEventToQueue(eventP);
			break;
		case ctlSelectEvent:
			return ExtWinSettingDoControl(eventP->data.ctlSelect.controlID);
			break;
	}
	
	return handled;
}

static void ExtModSetting(ExtWinModControlType *modCtrl)
{
	UInt16		prefsSize;
	ExtWinSettingGlbType	glb;
	Err			err;

	FormType	*frmP;
	UInt16		ret;
	UInt32		depth,saveDepth;
	RGBColorType	backRGB,saveRGB;
	RectangleType r;

	//O[o

	//pref l
	prefsSize = sizeof(ExtWinPreferenceType);
	PrefInit(glb.pref);
	err=PrefGetAppPreferences(extFileCreator, extPrefID, &(glb.pref), &prefsSize, true);
	if ( err == noPreferenceFound) {
	}

	//l	
	ExtUtilGetMgrOwnerTypeCreator(modCtrl,&(glb.type),&(glb.creator));
	glb.menuID=ExtUtilGetModuleMenuID(modCtrl);

	FtrSet(extFileCreator,extPrefFtr,(UInt32)(&glb));


	//UA\ 8bit J[ɂB
	FrmGetFormBounds(FrmGetActiveForm(),&r);
	
	backRGB.r=0xFF;
	backRGB.g=0xFF;
	backRGB.b=0xFF;
	WinSetForeColorRGB(&backRGB,&saveRGB);
	WinDrawRectangle(&r,0);
	WinSetForeColorRGB(&saveRGB,NULL);
	WinScreenMode(winScreenModeGet,NULL,NULL,&saveDepth,NULL);
	depth=8;
	WinScreenMode(winScreenModeSet,NULL,NULL,&depth,NULL);

	frmP = FrmInitForm (ExtWinSettingForm);
	FrmSetActiveForm(frmP);
	FrmSetEventHandler (frmP, ExtWinSettingHandleEvent);
	
	//tH[̏(`O)

	FrmDrawForm(frmP);
	
	//tH[̏(`)
	ExtWinSettingDrawForm();

	ret=FrmDoDialog(frmP);
	if(ret==ExtWinSettingOKButton){
		//fB
		PrefSetAppPreferences (extFileCreator, extPrefID, extPrefVersionNum, 
				&(glb.pref), sizeof(ExtWinPreferenceType), true);
	}

	FrmReturnToForm(0);

	FtrUnregister(extFileCreator,extPrefFtr);

	WinScreenMode(winScreenModeSet,NULL,NULL,&saveDepth,NULL);

}

#pragma mark //----W[
static void ExtModCountUp(ExtWinModControlType *modCtrl,UInt16 upCnt)
{
	ExtWinModType	*modData;

	//O[o̎o
	modData=modCtrl->glbP;

	//JEgAbv
	modData->cnt=modData->cnt+upCnt;
}

static void ExtModPaint(ExtWinModControlType *modCtrl)
{
	ExtWinModType	*modData;
	
	//ExtWinEraseRectangleCallBackPtr	ExtWinErase;
	RectangleType	r;

	UInt16		prefsSize;
	ExtWinPreferenceType	pref;
	Err			err;
	
	FontID				saveFont;
	WinDrawOperation	saveMode;
	UInt16				saveCoord;
	UInt16				saveDensity;
	RGBColorType		saveRGB;
	
	Char	tmp[10];
	Char	dateStr[longDateStrLength];
	UInt8	month;
	UInt8	day;
	UInt16	year;
	
	Char		*fldText;

	//O[o̎o
	modData=modCtrl->glbP;
	
	//pref l
	prefsSize = sizeof(ExtWinPreferenceType);
	PrefInit(pref);
	err=PrefGetAppPreferences(extFileCreator, extPrefID, &pref, &prefsSize, true);
	if ( err == noPreferenceFound) {
	}

	//wi
	WinGetBounds(WinGetDrawWindow(),&r);
	r.topLeft.x=0;
	r.topLeft.y=0;
	ExtUtilEraseRectangle(modCtrl,&r);

	//`揀
	saveFont=FntSetFont(largeFont);
	saveMode=WinSetDrawMode(winOverlay);
	saveCoord=WinSetCoordinateSystem(kCoordinatesStandard);
	saveDensity=BmpGetDensity(WinGetBitmap(WinGetDrawWindow()));
	BmpSetDensity(WinGetBitmap(WinGetDrawWindow()),kDensityLow);
	WinSetTextColorRGB(&(pref.textColor),&saveRGB);
	
	//JE^[`
	StrIToA(tmp,modData->cnt);
	WinPaintChars(tmp,StrLen(tmp),0,0);

	//I[i[`
	WinPaintChars((Char*)(&(modData->creator)),4,0,10);

	//j[ID`
	StrIToA(tmp,modData->menuID);
	WinPaintChars(tmp,StrLen(tmp),0,20);
	
	//tB[h̓e
	if(modData->fldP!=NULL){
		fldText=FldGetTextPtr(modData->fldP);
		if(fldText!=NULL){
			WinPaintChars(fldText,StrLen(fldText),0,30);
		}
	}

	//݂̓tw`
	if(ExtUtilGetSelectDay(modCtrl,&month,&day,&year)){
		//w肪
		DateToAscii(month,day,year,(DateFormatType)(PrefGetPreference(prefDateFormat)),dateStr);
	}else{
		StrCopy(dateStr,"--");
	}
	WinPaintChars(dateStr,StrLen(dateStr),0,40);

	//`㏈
	WinSetTextColorRGB(&saveRGB,NULL);
	BmpSetDensity(WinGetBitmap(WinGetDrawWindow()),saveDensity);
	WinSetCoordinateSystem(saveCoord);
	WinSetDrawMode(saveMode);
	FntSetFont(saveFont);

}

#pragma mark //---- Cxg
//
static Boolean ExtWinDoOpen(ExtWinModControlType *modCtrl)
{
	ExtWinModType	*modData;
	Boolean handled=false;

	//O[öm
	modData=MemPtrNew(sizeof(ExtWinModType));
	if(modData!=NULL){
		//|C^[Zbg
		modCtrl->glbP=modData;
		modCtrl->timeout=SysTicksPerSecond()*5;
	
		//
		MemSet(modData,sizeof(ExtWinModType),NULL);
		modData->cnt=0;
		modData->fldP=ExtUtilGetFocusField(modCtrl);
		//l	
		ExtUtilGetMgrOwnerTypeCreator(modCtrl,&(modData->type),&(modData->creator));
		modData->menuID=ExtUtilGetModuleMenuID(modCtrl);

		handled=true;
	}


	return handled;
}

//㏈
static Boolean ExtWinDoClose(ExtWinModControlType *modCtrl)
{
	Boolean handled=false;

	//O[öJ
	MemPtrFree(modCtrl->glbP);
	handled=true;

	return handled;
}


//ĕ`揈
static Boolean ExtWinDoRedraw(ExtWinModControlType *modCtrl)
{
	Boolean handled=false;
	
	ExtModPaint(modCtrl);
	
	handled=true;

	return handled;
}

//VXẽCxg
static Boolean ExtWinDoSysEvent(ExtWinModControlType *modCtrl)
{
	Boolean handled=false;

	switch(modCtrl->eventP->eType){
		case nilEvent:
		case penDownEvent:
			//̈yŉꂽB
			ExtModCountUp(modCtrl,1);
			if(ExtUtilUpdateWindow(modCtrl)==false){
				//CxgsłȂ̂ŁAڍĕ`
				ExtModPaint(modCtrl);
			}
			handled=true;
			break;
		case keyDownEvent:
			handled=false;
			if(ExtUtilGetKeyFocusStatus(modCtrl)!=extWinKeyFocusStatNone){
				//L[tH[JXݒ肳Ă郂[hkeyDown
				if(ExtUtilChkKeyFocusSwEvent(modCtrl)==false){ //ؑփL[D悳
					if(TxtCharIsHardKey(modCtrl->eventP->data.keyDown.modifiers,modCtrl->eventP->data.keyDown.chr) && vchrHard1<=modCtrl->eventP->data.keyDown.chr && modCtrl->eventP->data.keyDown.chr<=vchrHard4 ){
						if((modCtrl->eventP->data.keyDown.modifiers&poweredOnKeyMask)!=poweredOnKeyMask){
							//n[hL[ 1-4 (dON̉͏O) ̓JEgAbv
							ExtModCountUp(modCtrl,1);
							if(ExtUtilUpdateWindow(modCtrl)==false){
								//CxgsłȂ̂ŁAڍĕ`
								ExtModPaint(modCtrl);
							}
							handled=true;
						}
					}
				}
			}
			break;
			
	}

	return handled;
}

//ݒvCxg
static Boolean ExtWinDoSettingEvent(ExtWinModControlType *modCtrl)
{
	Boolean handled=false;

	ExtModSetting(modCtrl);
	handled=true;

	return handled;
}

//L[tH[JXݒvCxg
static Boolean ExtWinDoSetKeyFocus(ExtWinModControlType *modCtrl)
{
	Boolean handled=false;

	//L[tH[JX̐ݒv󂯕t(trueԂ)
	handled=true;

	return handled;
}

//L[tH[JXݒ\v
static Boolean ExtWinDoSetKeyFocusActDraw(ExtWinModControlType *modCtrl)
{
	Boolean handled=false;

	//L[tH[JX̐ݒ\v̓}l[W[ɂ܂(falseԂ)
	handled=false;

	return handled;
}

//L[tH[JXvCxg
static Boolean ExtWinDoClearKeyFocus(ExtWinModControlType *modCtrl)
{
	Boolean handled=false;

	//L[tH[JX̉

	return handled;
}

//twύXCxg
static Boolean ExtWinDoChgSelectDay(ExtWinModControlType *modCtrl)
{
	Boolean handled=false;

	//tw邱Ƃ}l[W[ɒʒmB(RedrawCxg󂯎)
	handled=true;

	return handled;
}

//foCXJnCxg
static Boolean ExtWinDoLateWakeup(ExtWinModControlType *modCtrl)
{
	Boolean handled=false;

	return handled;
}

//W[Gg[
Boolean	ExtWinModEntry(ExtWinModControlType *modCtrl)
{
	Boolean handled=false;

	switch(modCtrl->eType){
		case extWinModOpen:
			handled=ExtWinDoOpen(modCtrl);
			break;

		case extWinModClose:
			handled=ExtWinDoClose(modCtrl);
			break;

		case extWinModRedraw:
			handled=ExtWinDoRedraw(modCtrl);
			break;

		case extWinModSysEvent:
			handled=ExtWinDoSysEvent(modCtrl);
			break;

		case extWinModSettingEvent:
			handled=ExtWinDoSettingEvent(modCtrl);
			break;

		case extWinModSetKeyFocus:
			handled=ExtWinDoSetKeyFocus(modCtrl);
			break;

		case extWinModSetKeyFocusActDraw:
			handled=ExtWinDoSetKeyFocusActDraw(modCtrl);
			break;

		case extWinModClearKeyFocus:
			handled=ExtWinDoClearKeyFocus(modCtrl);
			break;
	
		case extWinModChgSelectDay:
			handled=ExtWinDoChgSelectDay(modCtrl);
			break;

		case extWinModLateWakeup:
			handled=ExtWinDoLateWakeup(modCtrl);
			break;
	}
	
	return handled;
}

